//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "DriverUSB.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TLedInter::TLedInter(TComponent* Owner, int i): TPanel(Owner)
{
	//initialisation du TPanel
    Parent = (TWinControl*)Owner;  //donner le controle  Form1
    Caption = "E/S"+AnsiString(NBITS-1-i);   //donner le nom a chaque LedInter
    SetBounds(MARGE+(i*(LGLI+MARGE)),  //
    	      ((MARGE*2)*MARGE)/2,     // cration du fond
              LGLI,                    // des lments
              HTLI);                   // LedInter

    //cration de l'Interrupteur
	Inter=new TCheckBox(this);
    Inter->Parent=this;             //pour donner le controle au parent
    Inter->SetBounds((LGLI/2)-(LHI/2), // dimenssionnement
    			     (5*HTLI)/6,       // des
                     LHI,              // interrupteurs
                     LHI);             //

    //cration de la Led
    Led=new TShape(this);
    Led->Parent=this;               //pour donner le controle au parent
    Led->SetBounds((LGLI/2)-(LHL/2),
                   (HTLI/6)-(LGLI/2),
                   LHL,
                   LHL);
    Led->Shape=stCircle;
    Led->Brush->Style=bsSolid;
    Led->Brush->Color=clMaroon;
    //dimenssionnement de la led et definition de sa forme
}
//---------------------------------------------------------------------------
__fastcall TSimuES::TSimuES(TComponent * Owner): TPanel(Owner)
{
   	Parent = (TWinControl*)Owner;        //donner le controle a Form1
    SetBounds(0,                             //
    	      0,                             //dessin de SimuE/S
              ((NBITS+1)*MARGE)+(NBITS*LGLI),//
              ((MARGE*2)*MARGE+HTLI));       //
    Lbl=new TLabel(this);
    Lbl->Parent=this;					//pour donner le controle au parent
    Lbl->Caption = "SimuE/S";
   	Lbl->Left=((Width)-(Lbl->Width))/2;	//centrer le texte sur SimuE/S
    Lbl->Top=(MARGE);
}
//---------------------------------------------------------------------------
bool __fastcall TSimuES::CreateGraf()
{
	for(int i=0;i<NBITS;i++) 			//dessiner les 8 lments LedInter
    {	tab[i]=new TLedInter(this,i);}
    return true;
}
//---------------------------------------------------------------------------
 void __fastcall TSimuES::AllumLed(unsigned char oct)
 {
 	for(int i=0;i<NBITS;i++)
    {	tab[NBITS-1-i]->ConnectLed((bool) (oct&(1<<i)));}
    //allume les leds en fonction de la valeur oct
 }
//---------------------------------------------------------------------------
unsigned char __fastcall TSimuES::LireInter()
{
	unsigned char num=0;
    //dclaration d'une variable utilise pour stocker notre rsultat
    for(int i=0;i<NBITS;i++)
    {	num+=(unsigned char)((0x80>>(NBITS-i-1))*tab[NBITS-1-i]->LireInter());}
    //calcul de la valeur positionne sur les inter
	return num;
}
//---------------------------------------------------------------------------
void __fastcall TSimuES::DeleteGraf()
{
	for(int i=0;i<NBITS;i++)
    {	delete tab[i];}           //dtruire l'objer SimuES
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SimuOnClick(TObject *Sender)
{
	TstSimu=new TSimuES(Form1);  //dessin de SimuE/S
    TstSimu->CreateGraf();         //appel  OpenPort pour dessiner les LedInter
    OpenPort();
    LirInter->Enabled=true; //
    LedInter->Enabled=true; // etat actif
    ChangLed->Enabled=true; // ou non des
    SimuOff->Enabled=true;  // boutons
    SimuOn->Enabled=false;  //
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LirInterClick(TObject *Sender)
{
	TstSimu->AllumLed(InPortUSB());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LedInterClick(TObject *Sender)
{
	OutPortUSB(InPortUSB());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ChangLedClick(TObject *Sender)
{
	OutPortUSB(TstSimu->LireInter());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SimuOffClick(TObject *Sender)
{
	TstSimu->DeleteGraf();	//dtruit les objets de SimuES
    delete TstSimu; 		//dtruit l'objer SimuE/S
    OutPortUSB(0);
    ClosePort();
    LirInter->Enabled=false; //
    LedInter->Enabled=false; // etat actif
    ChangLed->Enabled=false; // ou non des
    SimuOff->Enabled=false;  // boutons
    SimuOn->Enabled=true;    //
}
//---------------------------------------------------------------------------
