//------------------------------unit1.h-------------------------------------//
//Wafflard X.													4/03/02		//
//Manoukian A.																//
//controle builder															//
// etat d'avancement : tout marche + gestion diverses (affichage, power)	//
//--------------------------------------------------------------------------//
//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>

#define	NBITS 8  	//nombre de bits de l'interface
#define	MARGE 5     //marge et intervale entre les divers objets graphiques
#define	HTLI  150  	//hauteur du composant LedInter
#define LGLI  35	//largeur du compsant LedInter
#define LHI	  15	//largeur, hauteur Inter
#define LHL   15	//largeur, hauteur Led
//---------------------------------------------------------------------------
class TLedInter : public TPanel
{
	TCheckBox * Inter; //dclaration d'un objet de type TCheckBox (interrupteur)
    TShape * Led;      //dclaration d'un objet de type TShape (led)
    public:
    void __fastcall ConnectLed(bool On)
    {	Led->Brush->Color= On? clRed : clMaroon;} //led alum:rouge sinon maron
    bool __fastcall LireInter()
    {	return Inter->Checked ? true : false;}    //interrupteur ON ou OFF
    __fastcall TLedInter(TComponent * Owner, int i);//i indice  afficher
    __fastcall TLedInter(TComponent * Owner):TPanel(Owner){};
};
//---------------------------------------------------------------------------
class TSimuES : public TPanel
{
	TLabel * Lbl;	//dclaration d'un label de type TLabel
    TLedInter * tab[NBITS];//dclaration d'un tableau de pteurs pour 8 LedInter
    public:
    bool __fastcall CreateGraf();
    void __fastcall AllumLed(unsigned char oct); //oct : octet a afficher
    unsigned char __fastcall LireInter();
    void __fastcall DeleteGraf();
    __fastcall TSimuES(TComponent * Owner);
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
	TButton *SimuOn;                     //
	TButton *LirInter;                   // definition des
	TButton *LedInter;                   // differents
	TButton *ChangLed;                   // composants
	TButton *SimuOff;                    // de form1
	void __fastcall SimuOnClick(TObject *Sender);   //
	void __fastcall LirInterClick(TObject *Sender); // prototypes des
	void __fastcall LedInterClick(TObject *Sender); // fonctions lies
	void __fastcall ChangLedClick(TObject *Sender); // aux boutons
	void __fastcall SimuOffClick(TObject *Sender);  //
	    //
	     //
private:	// Dclarations de l'utilisateur
public:		// Dclarations de l'utilisateur
    __fastcall TForm1(TComponent* Owner);
 	TSimuES* TstSimu;	//dclaration de l'objer TSimuES
    unsigned char PLUS;	//variable modifiable envoye avec OutPortB()
};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
