//---------------------------------------------------------------------------
#ifndef DriverUSBH
#define DriverUSBH
//---------------------------------------------------------------------------
/*	Pilote du port usb version 1.0  utiliser avec le cypress CY7C63001A fourni
    par Elektor.
    Ralis le 20 juin 2002 par Artier Nicolas avec un CD d'installation. Ce CD
    contient le driver usbuart.sys qui permet a windows de connaitre l'interface
    dans sa liste de matriel. Lors de la premire connexion de l'interface le
    fichier usbuart.inf permet de copier directement le driver dans le bon rpertoire.
    Si jamais l'opration ne fonctionait pas il suffit de copier le .sys dans le
    rpertoire system32 de windows. Normalement le rpertoire doit contenir les
    autres drivers du port usb.
    Autrement il y a aussi un executable sur le CD permettant d'teindre toutes
    les leds du botier.

*/
    void __fastcall OutPortUSB(unsigned char val);

    unsigned char __fastcall InPortUSB();

    bool __fastcall OpenPort();

    void __fastcall ClosePort();

#endif
